require 'dp/structure'

@types = {}

def dp_type_dump(dp_type)
  dp_class = dp_type.value
  if dp_class.respond_to? :herit
    dp_class.herit.each do |tname|
      dtype = @types[tname.upcase]
      dp_type_dump(dtype) if dtype
    end if dp_class.herit
  end
  print dp_type.ident
  if dp_class.respond_to? :herit
    print ' ', '=', ' ', 'class'
    print '(', dp_class.herit.join(', '), ')' if dp_class.herit
  end
  print "\n"
  if dp_class.respond_to? :field_list
    up_mname = @dp_fieldname.upcase
    dp_class.field_list.each do |visib, field|
      next unless field && field.ident.upcase == up_mname
      print "\t"
      print visib, ' '
      if field
         print field.class, ' '
         print field.ident
         print '(', field.param_list.join(', '), ')' if field.param_list
         print ':', ' ', field.dtype.inspect if field.dtype
         if field.class == Delphi::Property
           print ' index=', field.index
           print ' read=', field.read
           print ' write=', field.write
           print ' stored=', field.stored
         end
      end
      print "\n"
    end
  end
end

@units = {}

def unit_loaded(uname, unit)
  @units[uname.upcase] = unit
end

def unit_loaded?(uname)
  @units[uname.upcase]
end

def loaded_unit(uname)
  @units[uname.upcase]
end

@type_unitname = {}

def dp_unit_load(unitname)
  dp_unit = Marshal.load(open("dpi/#{unitname}.dpi", "rb"))
  unit_loaded(unitname, dp_unit)
  dp_unit.interface.uses.each do |uname|
    dp_unit_load(uname) unless unit_loaded?(uname)
  end
  puts "unit=#{unitname}"
  dp_unit.interface.types.each do |dp_type|
    tname = dp_type.ident.upcase
    @type_unitname[tname] = unitname
    @types[tname] = dp_type
  end
end

def usage
  puts "Delphi Class Field Analyzer"
  puts "usage: ruby dp5.rb unit class.field"
  puts "ex: ruby dp5.rb StdCtrls TEdit.Font"
end

if ARGV.size < 2 then
  usage
  exit
end

uname = ARGV[0] || 'StdCtrls'
mname = ARGV[1] || 'TEdit.Font'
@dp_classname, @dp_fieldname = mname.split('.').map
# @dp_classname = 'TEdit'
# @dp_fieldname = 'Font'

puts "--params"
puts "unit=#{uname}"
puts "class=#{@dp_classname}"
puts "field=#{@dp_fieldname}"
puts "--"

dp_unit_load(uname)

def dp_unit_dump(unitname)
  dp_unit = loaded_unit(unitname)
  up_cname = @dp_classname.upcase
  dp_unit.interface.types.each do |dp_type|
    dp_type_dump(dp_type) if dp_type.ident.upcase == up_cname
  end
end

  up_cname = @dp_classname.upcase
uname = @type_unitname[up_cname]
if uname.nil?
  puts "class #{@dp_classname} not found"
  exit
end
dp_unit_dump(uname)
